/*
# NSC_LIC_COPYRIGHT
#
# Copyright (c) 2001-2003 National Semiconductor Corporation ("NSC").
#
# All Rights Reserved.  Unpublished rights reserved under the copyright 
# laws of the United States of America, other countries and international 
# treaties.  The software is provided without fee.  Permission to use, 
# copy, store, modify, disclose, transmit or distribute the software is 
# granted, provided that this copyright notice must appear in any copy, 
# modification, disclosure, transmission or distribution of the software.
#  
# NSC retains all ownership, copyright, trade secret and proprietary rights 
# in the software. 
# THIS SOFTWARE HAS BEEN PROVIDED "AS IS," WITHOUT EXPRESS OR IMPLIED 
# WARRANTY INCLUDING, WITHOUT LIMITATION, IMPLIED WARRANTIES OF 
# MERCHANTABILITY, FITNESS FOR A PARTICULAR USE AND NON-INFRINGEMENT.
#
# NSC does not assume or authorize any other person to assume for it any 
# liability in connection with the Software. NSC SHALL NOT BE LIABLE TO 
# COMPANY, OR ANY THIRD PARTY, IN CONTRACT, TORT, WARRANTY, STRICT 
# LIABILITY, OR OTHERWISE FOR ANY DIRECT DAMAGES, OR FOR ANY SPECIAL, 
# INDIRECT, INCIDENTAL OR CONSEQUENTIAL DAMAGES, INCLUDING BUT NOT 
# LIMITED TO, BUSINESS INTERRUPTION, LOST PROFITS OR GOODWILL, OR LOSS 
# OF INFORMATION EVEN IF NSC IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
# END_NSC_LIC_COPYRIGHT 
*/


#include "assyntax.h"

	FILE("nsc_msr_asm.s")

	AS_BEGIN

	SEG_TEXT

	ALIGNTEXT4

	GLOBL	GLNAME(nsc_asm_msr_vsa_rd)

GLNAME(nsc_asm_msr_vsa_rd):
	
	PUSH_L	(EBP)
	MOV_L	(ESP,EBP)

	PUSH_L	(EAX)
	PUSH_L	(EBX)
	PUSH_L	(ECX)
	PUSH_L	(EDX)
	
	MOV_L	(REGOFF(8,EBP),ECX)

	/* unlock */
	MOV_W	(CONST(0x0ac1c),DX)
	MOV_W	(CONST(0x0fc53),AX)
	OUT_W

	MOV_W	(CONST(0x0ac1c),DX)
	MOV_W	(CONST(0x0007),AX)
	OUT_W

	MOV_W	(CONST(0x0ac1e),DX)
	IN_W

	MOV_L	(REGOFF(12,EBP),EBX)
	MOV_L	(EDX,REGIND(EBX))
	MOV_L	(REGOFF(16,EBP),EBX)
	MOV_L	(EAX,REGIND(EBX))

	POP_L	(EDX)
	POP_L	(ECX)
	POP_L	(EBX)
	POP_L	(EAX)

	LEAVE
	RET

/*###################################*/


	ALIGNTEXT4

	GLOBL	GLNAME(nsc_asm_msr_vsa_wr)

GLNAME(nsc_asm_msr_vsa_wr):

	PUSH_L	(EBP)
	MOV_L	(ESP,EBP)

	PUSH_L	(EAX)
	PUSH_L	(EBX)
	PUSH_L	(ECX)
	PUSH_L	(EDX)
	PUSH_L	(EDI)
	PUSH_L	(ESI)

	MOV_L	(REGOFF(8,EBP),ECX)

	/* unlock */
	MOV_W	(CONST(0x0ac1c),DX)
	MOV_L	(CONST(0x0fc530007),EAX)
	OUT_L
	
	MOV_L	(REGOFF(12,EBP),EBX)
	MOV_L	(REGOFF(16,EBP),EAX)

	XOR_L	(ESI,ESI)
	XOR_L	(EDI,EDI)

	MOV_W	(CONST(0x0ac1e),DX)

	OUT_W

	POP_L	(ESI)
	POP_L	(EDI)
	POP_L	(EDX)
	POP_L	(ECX)
	POP_L	(EBX)
	POP_L	(EAX)

	LEAVE
	RET

/*###################################*/

